﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace SLabelDesign
{
    public partial class FormPrinter : Form
    {

        private string zplCode;

        public FormPrinter(string zpl)
        {
            InitializeComponent();
            this.zplCode = zpl;
            
        }

        private void FormPrinter_Load(object sender, EventArgs e)
        {
            comboBox_printerList.Items.Clear();

            System.Drawing.Printing.PrintDocument print = new System.Drawing.Printing.PrintDocument();
            string sDefault = print.PrinterSettings.PrinterName;//默认打印机名
            foreach (string sPrint in System.Drawing.Printing.PrinterSettings.InstalledPrinters)//获取所有打印机名称
            {
                comboBox_printerList.Items.Add(sPrint);
            }
            comboBox_printerList.Text = sDefault;
            txt_zpl.Text = zplCode;
          
        }

        private void btn_print_Click(object sender, EventArgs e)
        {

            
            foreach (string str in txt_zpl.Lines)
            {
                RawPrinterHelper.SendStringToPrinter(comboBox_printerList.Text, str);
            }
 
            //RawPrinterHelper.SendStringToPrinter(comboBox_printerList.Text, this.zplCode);
        }

        private void comboBox_printerList_SelectedValueChanged(object sender, EventArgs e)
        {
            System.Drawing.Printing.PrinterSettings prtSet = new System.Drawing.Printing.PrinterSettings();
            prtSet.PrinterName = comboBox_printerList.Text;
            System.Drawing.Printing.PrinterResolution[] prlAry = new System.Drawing.Printing.PrinterResolution[prtSet.PrinterResolutions.Count];
            prtSet.PrinterResolutions.CopyTo(prlAry, 0);
            int dpi = prlAry[prtSet.PrinterResolutions.Count - 1].X;
            label_DPI.Text=("DPI：" + dpi);
            
        }

    }
}
