﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace SLabelDesign
{
    public class HelperRectangleSeletControl
    {
        private Control control;

        public delegate void Handle_RectangleSeletedControls(Control ctl);
        public event Handle_RectangleSeletedControls handle_RectangleSeletedControls;

        public void initProperty(Control ctl)
        {
            control = ctl;
            control.MouseDown += new System.Windows.Forms.MouseEventHandler(RectSeletMouseDown);
            control.MouseUp += new System.Windows.Forms.MouseEventHandler(RectSeletMouseUp);
            control.MouseMove += new System.Windows.Forms.MouseEventHandler(RectSeletMouseMove);
            control.MouseClick += new System.Windows.Forms.MouseEventHandler(RectSeletMouseClick);
        }

        //定义两个变量 
        bool MouseIsDown = false;
        Point MouseStartPos = new Point();
        Rectangle MouseRect = Rectangle.Empty; //矩形（为鼠标画出矩形选区）

        //定义三个方法
        private void ResizeToRectangle(object sender, Point p)
        {
            DrawRectangle(sender);
            MouseRect.Width = p.X - MouseRect.Left;
            MouseRect.Height = p.Y - MouseRect.Top;
            DrawRectangle(sender);
        }
        private void DrawRectangle(object sender)
        {
            Rectangle rect = ((Panel)sender).RectangleToScreen(MouseRect);
            ControlPaint.DrawReversibleFrame(rect, Color.White, FrameStyle.Dashed);
        }

        private void DrawStart(object sender, Point StartPoint)
        {
            ((Panel)sender).Capture = true;
            Cursor.Clip = ((Panel)sender).RectangleToScreen(((Panel)sender).Bounds);
            MouseRect = new Rectangle(StartPoint.X, StartPoint.Y, 0, 0);
        }

        private void RectSeletMouseDown(object sender, MouseEventArgs e)
        {
            MouseIsDown = true;
            MouseStartPos = Control.MousePosition;
            DrawStart(sender, e.Location);
        }

        private void RectSeletMouseUp(object sender, MouseEventArgs e)
        {

            control.Capture = false;
            Cursor.Clip = Rectangle.Empty;
            MouseIsDown = false;
            DrawRectangle(sender);
            MouseRect = Rectangle.Empty;
        }

        private void RectSeletMouseMove(object sender, MouseEventArgs e)
        {
            
            if (MouseIsDown)
            {
                ResizeToRectangle(sender, e.Location);
            }
                
            foreach (Control ctl in ((Panel)sender).Controls)
            {
                // MouseRect.IntersectsWith : 相交
                // MouseRect.Contains  : 完全包含
                if (MouseRect.Contains(ctl.Bounds))
                {
                    //button.BackColor = Color.Blue;
                    handle_RectangleSeletedControls(ctl);
                }
            }

        }

        private void RectSeletMouseClick(object sender, MouseEventArgs e)
        {
            Point curMousePos = Control.MousePosition;
            if(curMousePos.X==MouseStartPos.X && curMousePos.Y == MouseStartPos.Y)
            {
                Graphics.FromHwnd(control.Handle).Clear(control.BackColor);
            }  
        }
    }
}
